<?php
/*
Plugin Name: 简数采集器-Destoon免登录发布接口
Description: 简数(keydatas.com)数据采集器是一个完全在线配置和云采集的通用网页数据采集工具，功能强大，操作简单。支持定时采集，自动发布；图片下载支持存储到阿里云OSS、七牛对象存储、腾讯云对象存储。
Version: 1.0.3
License: GPLv2 or later
*/
$_REQ = keydatas_mergeRequest();
require_once '../common.inc.php';
require_once '../module/member/member.class.php';
require 'ConfigDao.php';

if (isset($_REQ["__kds_flag"])){
if ($_REQ["__kds_flag"] == "post") {//提交

		//密码校验
		$keydatas_config_password='keydatas_password';
		$configJson=ConfigDao::getConfig();
		$kds_password =$configJson['keydatas_password'];
		if (empty($_REQ['kds_password']) || $_REQ['kds_password'] != $kds_password) {
			keydatas_failRsp(1403, "password error", "提交的发布密码错误");
		}	
		
		//检查标题		
		$title  = isset($_POST['title']) ? $_POST['title'] : '';//标题	
		if (empty($title)) {
			keydatas_failRsp(1404, "title is empty", "标题不能为空");
		}
		//检查内容		
		$content  = isset($_POST['content']) ? $_POST['content'] : '';
		if (empty($content)) {
			keydatas_failRsp(1404, "content is empty", "内容不能为空");
		}
		
		//重要，系统模型id，article默认是21
		$moduleid = isset($_POST['moduleid']) ? $_POST['moduleid'] :'21';//	
					
	try{
		//标题唯一校验			
		$keydatas_title_unique =$configJson['keydatas_title_unique'];
		if($keydatas_title_unique=='true'){
			$itemId=isTitleUnique($title,$moduleid);		
			//只返回id
			if($itemId){
				$tmpModuleDir=findModuleDir($moduleid);
				
				$docFinalUrl=DT_PATH.$tmpModuleDir.'/'.'show.php?itemid='.$itemId;;
				//返回访问路径
				keydatas_successRsp(array("url" => $docFinalUrl));	
				//相同返回失败			
				
			}
		}// 
		
		//发布日期处理
		$addtime  = isset($_POST['addtime']) ? $_POST['addtime'] : time();
		if(empty($addtime)){
			$addtime=time();
		}		
		
		//
	//1、分类校验，看分类是否存在，先按ID查询，如果ID不存在，按名称查询，如果都不存在，返回错误提示
	if(isset($_POST['catid'])){
		$cateIdOrNameStr=trim($_POST['catid']);
				if(is_numeric($cateIdOrNameStr)){
			if(existCategory($cateIdOrNameStr,$moduleid)){
				$catid=$cateIdOrNameStr;
			}else{
				keydatas_failRsp(1404, "log_CateID no exist", "发布目标映射中指定的分类ID不存在,".$cateIdOrNameStr);
			}
		}else{//按名称获取
			$catename = trim($cateIdOrNameStr);
			$newcateId=getCategoryByName($catename,$moduleid);//GetCategoryByAliasOrName  GetCategoryByName
				
			if ($newcateId>0){
				$catid=$newcateId;  
			}else{
				keydatas_failRsp(1404, "cate name no exist", "发布目标映射中指定的分类名称不存在");

			}
		}
	}else{
		keydatas_failRsp(1404, "catid is empty", "发布目标映射中未指定分类ID");
	}
		//用	_POST获取不到
		$areaid  = isset($_POST['areaid']) ? $_POST['areaid'] : '1';//
		$level  = isset($_POST['level']) ? $_POST['level'] : '0';//
		$title  = isset($_POST['title']) ? $_POST['title'] : '';//
		$style  = isset($_POST['style']) ? $_POST['style'] : '';//
		$fee  = isset($_POST['fee']) ? $_POST['fee'] : '0';//
		$subtitle  = isset($_POST['subtitle']) ? $_POST['subtitle'] : '';
		$introduce  = isset($_POST['introduce']) ? $_POST['introduce'] : '';
		$tag  = isset($_POST['tag']) ? $_POST['tag'] : '';
		$keyword  = isset($_POST['keyword']) ? $_POST['keyword'] : '';//
		$author  = isset($_POST['author']) ? $_POST['author'] : '';
		$copyfrom  = isset($_POST['copyfrom']) ? $_POST['copyfrom'] : '';
		$fromurl  = isset($_POST['fromurl']) ? $_POST['fromurl'] : '';
		$voteid  = isset($_POST['voteid']) ? $_POST['voteid'] : '';
		$hits  = isset($_POST['hits']) ? $_POST['hits'] : '0';
		$comments  = isset($_POST['comments']) ? $_POST['comments'] : '0';
		$thumb  = isset($_POST['thumb']) ? $_POST['thumb'] : '';
		$username  = isset($_POST['username']) ? $_POST['username'] : '';//会员名
		
		$editor  = isset($_POST['editor']) ? $_POST['editor'] : '';
		$edittime  = $addtime;
		$ip  ='';
		$template  = isset($_POST['template']) ? $_POST['template'] : '';
		$status  = isset($_POST['status']) ? $_POST['status'] : '0';
		$islink  = isset($_POST['islink']) ? $_POST['islink'] : '0';
		$linkurl  = isset($_POST['linkurl']) ? $_POST['linkurl'] : '';
		$filepath  = isset($_POST['filepath']) ? $_POST['filepath'] : '';
		$note  = isset($_POST['note']) ? $_POST['note'] : '';
		//扩展
		$urlRewrite=isset($_POST['urlRewrite']) ? trim($_POST['urlRewrite']) : '';
		
		$articleTable = $DT_PRE.'article_'.$moduleid;
		$articleTable_data = $DT_PRE.'article_data_'.$moduleid;
			
		//写入数据库 
		$sql = "insert into $articleTable (`itemid`,`catid`,`areaid`,`level`,`title`,`style`,`fee`,`subtitle`,`introduce`,`tag`,`keyword`,`author`,`copyfrom`,`fromurl`,`voteid`,`hits`,`comments`,`thumb`,`username`,`addtime`,`editor`,`edittime`,`ip`,`template`,`status`,`islink`,`linkurl`,`filepath`,`note`) values (NULL,'$catid','$areaid','$level','$title','$style','$fee','$subtitle','$introduce','$tag','$keyword','$author','$copyfrom','$fromurl','$voteid','$hits','$comments','$thumb','$username','$addtime','$editor','$edittime','$ip','$template','$status','$islink','$linkurl','$filepath','$note');"; 		
		$db->query("begin;");
		try{
			$db->query($sql);
			$idData = $db->get_one("select last_insert_id() as last_item_id");
			$newItemId = $idData['last_item_id'];
			//插入内容
			$db->query("insert into {$articleTable_data}(itemid,content) values ($newItemId,'$content')");
			$newLinkUrl = updateLinkUrl($newItemId,$moduleid,$urlRewrite);
			$db->query("commit;");
		}catch (Exception $e){
			$db->query("rollback;");
			keydatas_failRsp(1500, "insert db error", "插入数据库异常:".$e->getMessage());
		}
		if(!$newLinkUrl){
		   keydatas_failRsp(1500, "save error", "文章插入失败");
		}
		$moduleDir=findModuleDir($moduleid);
		$finalUrl=DT_PATH.$moduleDir.'/'.$newLinkUrl;
		
		
		downloadImages($_REQ);	
		keydatas_successRsp(array("url" => $finalUrl));
	} catch (Exception $ex) {
		
		keydatas_failRsp(500,'save-error',$ex->getMessage());  
	}		
	}
}

/**
检查分类id是否存在
**/
function existCategory($catid,$moduleid){
	global $DT_PRE,$db;	
	$sql = "select catid from {$DT_PRE}category where catid=$catid and moduleid=$moduleid ";	
	$rowData = $db->get_one($sql);	
	return isset($rowData['catid'])?true:false;
}

function  getCategoryByName($catname,$moduleid){
	global $DT_PRE,$db;
	$sql = "select catid from {$DT_PRE}category where catname='$catname' and moduleid=$moduleid";
	$rowData = $db->get_one($sql);
	return isset($rowData['catid'])?$rowData['catid']:0;	
}

function isTitleUnique($title,$moduleid){
	global $DT_PRE,$db;
	$sql = "select itemid from {$DT_PRE}article_{$moduleid} where title='$title'";
	$rowData = $db->get_one($sql);
	return isset($rowData['itemid'])?$rowData['itemid']:false;
}

function updateLinkUrl($itemid,$moduleid,$urlRewrite){
	global $DT_PRE,$db;
	$linkurl='show.php?itemid='.$itemid;
	if(!empty($urlRewrite)){
		$linkurl=str_replace('#id#',$itemid,$urlRewrite);
	}
	if(empty($linkurl)){
		$linkurl='show.php?itemid='.$itemid;
	}
	$sql = "update {$DT_PRE}article_{$moduleid} set linkurl= '$linkurl' where itemid=$itemid ";
	$db->query($sql);
	return $linkurl;
}
function findModuleDir($moduleid){
	global $DT_PRE,$db;
	$rowData = $db->get_one("select moduledir from {$DT_PRE}module where moduleid=$moduleid");
	return $rowData['moduledir'];
}


function  downloadImages($post){

  try{
	$downloadFlag = isset($post['__kds_download_imgs_flag']) ? $post['__kds_download_imgs_flag'] : '';
	
	if (!empty($downloadFlag) && $downloadFlag== "true") {
		$docImgsStr = isset($post['__kds_docImgs']) ? $post['__kds_docImgs'] : '';
		
		if (!empty($docImgsStr)) {
			$docImgs = explode(',',$docImgsStr);
			if (is_array($docImgs)) {
				//
				$upload_dir = getFilePath();
				foreach ($docImgs as $imgUrl) {
					$urlItemArr = explode('/',$imgUrl);
					$itemLen=count($urlItemArr);
					if($itemLen>=3){
						
						$fileRelaPath=$urlItemArr[$itemLen-3].'/'.$urlItemArr[$itemLen-2];
						$imgName=$urlItemArr[$itemLen-1];
						$finalPath=$upload_dir. '/'.$fileRelaPath;
						
						if (create_folders($finalPath)) {
							$file = $finalPath . '/' . $imgName;
							if(!file_exists($file)){
								$doc_image_data = file_get_contents($imgUrl);
								file_put_contents($file, $doc_image_data);
							}
						}
					}
				}//.for
			}//..is_array
		}				
	}
 } catch (Exception $ex) {
	
 }		
}

    /**
     * 获取文件完整路径
     * @return string
     */
function getFilePath(){
	return DT_ROOT. '/file/upload';
}
function create_folders($dir){ 
	return is_dir($dir) or (create_folders(dirname($dir)) and mkdir($dir, 0777)); 
}	

function keydatas_mergeRequest() {
    if (isset($_GET['__kds_flag'])) {
        $_REQ  = array_merge($_GET, $_POST);
    } else {
        $_REQ  = $_POST;
    }
    return $_REQ ;
}

function keydatas_successRsp($data = "", $msg = "") {
    keydatas_rsp(1,0, $data, $msg);
}
function keydatas_failRsp($code = 0, $data = "", $msg = "") {
    keydatas_rsp(0,$code, $data, $msg);
}
function keydatas_rsp($result = 1,$code = 0, $data = "", $msg = "") {
	die(json_encode(array("rs" => $result, "code" => $code, "data" => $data, "msg" => urlencode($msg))));
}

?>